﻿Imports System.Security.Cryptography
Imports System.Text
Imports System.Numerics

Module Module1

    Public Function getBytesFromString(ByVal x As String) As Byte()
        Static z As New UTF8Encoding()
        Return z.GetBytes(x)
    End Function

    Public Function getHashFrom3BytesArrays(ByVal x As Byte(), ByVal y As Byte(), ByVal z As Byte()) As Byte()
        Dim r As RIPEMD160 = RIPEMD160Managed.Create()
        r.TransformBlock(x, 0, x.Length, x, 0)
        r.TransformBlock(y, 0, y.Length, y, 0)
        r.TransformFinalBlock(z, 0, z.Length)
        Return r.Hash
    End Function

    Public Function getBigIntFromHash(ByVal x As Byte()) As BigInteger
        Dim z As Byte() = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        For i As Integer = 0 To 19
            z(i) = x(19 - i)
        Next
        Return New BigInteger(z)
    End Function

    Public Function divideAndGetRemainder(ByRef x As BigInteger) As Integer
        Static BIGINT_62 As BigInteger = 62
        Static remainder As BigInteger = BigInteger.Zero
        x = BigInteger.DivRem(x, BIGINT_62, remainder)
        Return CInt(remainder)
    End Function

    Public Function getSymbolByIndex(ByVal x As Integer) As Char
        If x < 10 Then
            x += 48
        ElseIf x < 36 Then
            x += 55
        Else
            x += 61
        End If
        Return ChrW(x)
    End Function

    Public Function getPassWordFrom3Strings(ByVal x As String, ByVal y As String, ByVal z As String) As String
        Dim n As BigInteger = getBigIntFromHash(getHashFrom3BytesArrays(getBytesFromString(x),
                                                                        getBytesFromString(y),
                                                                        getBytesFromString(z)))
        Dim p As StringBuilder = New StringBuilder(28)
        Do Until n.IsZero
            p.Append(getSymbolByIndex(divideAndGetRemainder(n)))
        Loop
        Return p.ToString
    End Function

End Module
